// SM1628
// JUAN GALAZ SAINZ
// SETA43
// 10/12/2020
// BASADO EN LIBRERIA TM1628 MODIFICADA
// https://github.com/BlockThor/TM1628


#include <IRremote.h>
#define PinIR   11

IRrecv irrecv(PinIR);

decode_results results;
int codeType = -1;
int ledPin = 12;
int ledTest = 13;


const int dataPin = 5;   
const int clockPin = 4;  
const int strobePin = 3; 

int button;

unsigned char numerosD[11]={223,144,235,249,244,61,127,152,255,253};
unsigned char digitos[5];

int contador;
int minutos,segundos,tiempo;
int modo;



void setup()
{
  Serial.begin(9600);
  Serial.println("SM1628");
  
  irrecv.enableIRIn(); // Start the receiver 
  pinMode(ledPin, OUTPUT);
  pinMode(ledTest, OUTPUT);
 
  initSM1628();
  printDigitos(8888);  
  for (int i=0; i<7; i++)   {  lightSM1628(i); delay(200);   } 
  printDigitos(0); 
  printGraf(0);
  digitalWrite(ledPin, LOW); 
  modo=-1;
  minutos=0; segundos=0;
  printDigitos(minutos*100+segundos);
}



void loop()
{  
  contador++;
  
    if(modo==0 && contador==700) printGraf(128);
    if(modo==0 && contador>1000)
    {
      printGraf(0);
      contador=0;
      segundos--;
      if(segundos<0) 
        {
          segundos=59;
          minutos--;          
        }
      if(segundos==0 && minutos==0){ digitalWrite(ledPin, HIGH); modo=-1;}
      if(minutos<0){segundos=0; minutos=0; modo=-1;}
      printDigitos(minutos*100+segundos);
    }
     
  if (irrecv.decode(&results))
  {
    digitalWrite(ledTest, HIGH);
    Serial.println("-------");
    Serial.print("HEXC=");Serial.print(results.value, HEX);  
    Serial.print("  DEC_L=");Serial.println(results.value & 255, DEC);
    codeType = results.decode_type;
    Serial.print("codeType "); Serial.println(codeType);

    switch (codeType)
    {
      case RC5:
        Serial.println("Received RC5: ");  
        switch (results.value & 255)
        {
          case 16:    
             incre();
          break;
          case 17: 
             decre();                
          break;
          case 13:
            changeModo();
          break;
        }
        delay(100);
        break;
        
      case RC6:
        Serial.println("Received RC6: ");
        break;
      case NEC:
        Serial.println("Received NEC: ");        
        switch (results.value & 255)
        {
          case 215:
              incre();
          break;
          case 191:
              incre();
          break;
          case 23:
             decre();
          break;
          case 63:
             decre();
          break;
          case 111:
            changeModo();
          break;
          case 151:
            changeModo();
          break;
        }
        delay(100);
        break;
      case SONY:
        Serial.println("Received SONY: ");
        break;
      default:
        Serial.print("Unexpected codeType ");
        Serial.print(codeType, DEC);
        Serial.println("---");
        break;
    }

    irrecv.resume(); // Recibiendo nuevo valor
    digitalWrite(ledTest, LOW);
  }

  button = getButtons();
  if (button != 0)
    {
     for(int i=0;i<8;i++)
      { 
        if((button >> i) & 0x01) 
          {
            Serial.println(button);
            switch (button)
                {
                  case 2:
                      incre();
                  break;
                  case 8:
                      decre();
                  break;
                  case 1:
                    changeModo();
                  break;
                }
                delay(300);
          } 
      }
    }
}



void changeModo(void)
{
      contador=0;
      if(modo==-1) modo=0;
      modo++;           
      if(modo==3) { modo=0;     }
      printGraf(modo);
      digitalWrite(ledPin, LOW);
}

void incre(void)
{
      if(modo==1)segundos++;
      if(segundos>59)segundos=0;
      if(modo==2)minutos++;
      if(minutos>59) minutos=0;
      printDigitos(minutos*100+segundos);
}

void decre(void)
{
    if(modo==1) segundos--;
    if(segundos<0)segundos=59;
    if(modo==2) minutos--;
    if(minutos<0)minutos=59;
    printDigitos(minutos*100+segundos);
}


//________LIBRERIAS PARA SM1628   _____________

//void initSM1628(int dataPin,int clockPin,int strobePin)
void initSM1628(void)
{
  pinMode(dataPin, OUTPUT);
  pinMode(clockPin, OUTPUT);
  pinMode(strobePin, OUTPUT);

  digitalWrite(strobePin, HIGH);
  digitalWrite(clockPin, HIGH);
  t_sendCommand(0x40);
  t_sendCommand(0x88 | 7);  //Brillo
  digitalWrite(strobePin, LOW);

  for (int i=0; i<5; i++) sendDato(i,0); //borrar
  digitalWrite(strobePin, HIGH);
}

void lightSM1628(unsigned char i)   {  t_sendCommand(0x88 | (7&i));}
void printGraf(unsigned char m)    { sendDato(0,0xff&m);  }  //Graficos

//numero

void printDigitos(int num)
{
    sprintf(digitos,"%04d",num);   
    sendDato(1,numerosD[(digitos[0]-48)]);
    sendDato(2,numerosD[(digitos[1]-48)]);
    sendDato(3,numerosD[(digitos[2]-48)]);
    sendDato(4,numerosD[(digitos[3]-48)]);     
}

void sendDato(byte direccion, byte data)
{
  direccion*=2;
  t_sendData(direccion,data&0xFF);
  t_sendData(direccion+1,(data&0xFF)>>4);
}

//http://blockduino.blogspot.com/2012/10/led-dvd-tm1628.html
void t_sendCommand(byte cmd)
{
  digitalWrite(strobePin, LOW);
  t_send(cmd);
  digitalWrite(strobePin, HIGH);
}

void t_sendData(byte address, byte data)
{
  t_sendCommand(0x44);
  digitalWrite(strobePin, LOW);
  t_send(0xC0 | address);
  t_send(data);
  digitalWrite(strobePin, HIGH);
}

void t_send(byte data)
{
  for (int i = 0; i < 8; i++) {
    digitalWrite(clockPin, LOW);
    digitalWrite(dataPin, data & 1 ? HIGH : LOW);
    data >>= 1;
    digitalWrite(clockPin, HIGH);
  }
}


byte getButtons() 
{
  byte keys = 0;
    digitalWrite(strobePin, LOW);
    t_send(0x42);
    for (int i = 0; i < 5; i++)  keys |= receive() << i;
    digitalWrite(strobePin, HIGH);
    return keys;
}


byte receive() 
{
  byte temp = 0;
    pinMode(dataPin, INPUT);
    digitalWrite(dataPin, HIGH); 
    for (int i = 0; i < 8; i++) 
      {
        temp >>= 1;
        digitalWrite(clockPin, LOW);
        if (digitalRead(dataPin)) temp |= 0x80;
        digitalWrite(clockPin, HIGH);
      } 
    pinMode(dataPin, OUTPUT);
    digitalWrite(dataPin, LOW);
    return temp;
}

//_____________________________
